opal/mca/timer/timer.h File Reference.TH "opal/mca/timer/timer.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
opal/mca/timer/timer.h \- High resolution timer / cycle counter. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'mca/mca.h'\fP
.br
\fC#include 'mca/base/base.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBOPAL_TIMER_BASE_VERSION_1_0_0\fP"
.br
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBopal_timer_base_component_1_0_0_t\fP \fBopal_timer_base_component_1_0_0_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.in -1c
.SH "Detailed Description"
.PP 
High resolution timer / cycle counter. 

High resolution timer / cycle counter interface. This interface is intended to hide the system-dependent nature of timers that provide higher resolution and lower calling cost than gettimeofday(). Unlike most component interfaces, there should only ever be one component available to be built on a particular platform. Therefore, a number of #defines are available to determine how well the platform supports high resolution timers:
.PP
.PD 0
.IP "\(bu" 2
.PP
.nf
OPAL_TIMER_CYCLE_NATIVE
.fi
.PP
 Whether opal_timer_base_get_cycle() is implemented directly or computed from some other data (such as a high res timer) 
.IP "\(bu" 2
.PP
.nf
OPAL_TIMER_CYCLE_SUPPORTED
.fi
.PP
 Whether opal_timer_base_get_cycle() is supported on the current platform. 
.IP "\(bu" 2
.PP
.nf
OPAL_TIMER_USEC_SUPPORTED
.fi
.PP
 Whether opal_timer_base_get_usec() is supported on the current platform or implemented on top of gettimeofday(), which may be unsuitable for some uses. 
.PP
.PP
The cycle count may not be the cycle count of the CPU itself, if there is another sufficiently close counter with better behavior characteristics (like the Time Base counter on many Power/PowerPC platforms). The function opal_timer_base_get_freq() returns the frequency of the cycle counter in use, *NOT* the frequency of the main CPU.
.PP
Unless otherwise noted, no attempt is made to cope with the the differences in counters on SMP machines. If your process switches CPUs, your timer results may change.
.PP
Build time priorities are allocated as follows:
.PP
.IP "\(bu" 2
0 gettimeofday() wrapper
.IP "\(bu" 2
10 Assembly timers with bad frequency search (Linux)
.IP "\(bu" 2
20 NIC software stack (QSNet, Myrinet?)
.IP "\(bu" 2
30 Operating systems with native interfaces
.PP

.SH "Define Documentation"
.PP 
.SS "#define OPAL_TIMER_BASE_VERSION_1_0_0"
.PP
\fBValue:\fP
.PP
.nf
/* timer v1.0 is chained to MCA v1.0 */ \
    MCA_BASE_VERSION_1_0_0, \
    /* timer v1.0 */ \
    'timer', 1, 0, 0
.fi
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
